// fuck your language limitations
// just require an ABI or a I/O interface instead of being cringe

#[link(name = "impl")]
extern "C" {
    pub fn entry_impl(
        haystack: *const u8,
        s_haystack: usize,
        needle: *const u8,
        s_needle: usize,
        start: *mut usize,
        gap: *mut usize,
    ) -> bool;
}

pub fn entry(haystack: &str, needle: &str) -> Option<(usize, usize)> {
    let mut start = 0;
    let mut gap = 0;

    let succ = unsafe {
        entry_impl(
            haystack.as_ptr(),
            haystack.len(),
            needle.as_ptr(),
            needle.len(),
            &mut start as *mut usize,
            &mut gap as *mut usize,
        )
    };

    if succ {
        Some((start, gap))
    } else {
        None
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn sad_succeeds() {
        assert_eq!(
            entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "SAD"),
            Some((10, 8))
        );
    }

    #[test]
    fn scam_succeeds() {
        assert_eq!(
            entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "SCAM"),
            Some((9, 4))
        );
    }

    #[test]
    fn gay_succeeds() {
        assert_eq!(
            entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "GAY"),
            Some((39, 0))
        );
    }

    #[test]
    fn sick_fails() {
        assert_eq!(
            entry("THISBOOKISSOFUCKINGAWESOMEANDIAMTOTALLYGAY", "SICK"),
            None
        );
    }
}
